(display "Booting personal TeXmacs initialization file\n")
(exec-file "$TEXMACS_PATH/progs" "init-texmacs.scm")

(define (mycas-simplify t)
  (cond ((func? t 'document 1) (mycas-simplify (cadr t)))
	((func? t 'with) (rcons (cDr t) (mycas-simplify (cAr t))))
	(else t)))

(define (mycas-expand)
  (if (selection-active-any?)
      (let* ((t (the-selection))
	     (u (connection-eval "mycas" "default" t))
	     (v (object->tree (mycas-simplify (tree->object u)))))
	(cut "primary")
	(insert-tree v))))

(set-keymap (always?)
  ("F9" (mycas-expand)))
